//{$WARNINGS OFF}
{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  SDIApp̎qtH[̃R[h
//  NXTSDIChildForm
//=============================================================================
unit SDIChildFormUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Menus, ComCtrls;

type
  TSDIChildForm = class(TForm)
    MainMenu1: TMainMenu;
    menuFile: TMenuItem;
    menuNewForm: TMenuItem;
    N1: TMenuItem;
    menuClose: TMenuItem;
    menuCloseAll: TMenuItem;
    menuDisplay: TMenuItem;
    menuCascadeWindow: TMenuItem;
    menuTileVertical: TMenuItem;
    menuTileHorizontal: TMenuItem;
    menuMinimizedAll: TMenuItem;
    RichEdit1: TRichEdit;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure menuNewFormClick(Sender: TObject);
    procedure menuCloseClick(Sender: TObject);
    procedure menuCloseAllClick(Sender: TObject);
    procedure menuCascadeWindowClick(Sender: TObject);
    procedure menuTileVerticalClick(Sender: TObject);
    procedure menuTileHorizontalClick(Sender: TObject);
    procedure menuMinimizedAllClick(Sender: TObject);
  private
    { Private 錾 }
  protected
    procedure CreateParams(var Params: TCreateParams); override;
    function GetClassNameStr(hWindow: HWND): string;
  public
    { Public 錾 }
  end;

var
  SDIChildForm: TSDIChildForm;
  NotFirstForm: Boolean;


implementation

uses SDIMainFormUnit;

{$R *.DFM}

//-----------------------------------------------------------------------------
//  ŌɕtH[`FbN
//  Ō̏ꍇTrueԂCłȂꍇFalseԂ
//-----------------------------------------------------------------------------
function IsLastForm(Form: TForm): Boolean;
var
  i     : Integer;
  AForm : TForm;
  Flag  : Boolean;
begin
  Result :=  True;

  for i := 0 to Screen.FormCount - 1 do begin
    AForm := Screen.Forms[I];

    Flag := (AForm.ParentWindow = 0)
            or AForm.HandleAllocated
            or not IsChild(AForm.Handle, AForm.ParentWindow);
    if (AForm <> Form) and AForm.Visible and Flag then begin
      Result := False;
      Break;
    end;
  end;
end;

//=============================================================================
//  tH[\Jn̏
//=============================================================================
procedure TSDIChildForm.FormShow(Sender: TObject);
begin
 if not NotFirstForm then begin
   NotFirstForm := True;
   //ŏɕ\tH[CmdShowɏ]
   case CmdShow of
     SW_SHOWMINNOACTIVE: WindowState := wsMinimized;
     SW_SHOWMAXIMIZED:   WindowState := wsMaximized;
   end;
 end;
end;

//=============================================================================
//  ̃tH[鎞̏
//  ̃tH[Ōł΃AvP[VI
//  if IsLastForm(Self) then SDIMainForm.Close; łOK
//=============================================================================
procedure TSDIChildForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action := caFree;
  if IsLastForm(Self) then SDIMainForm.Close;
end;

//=============================================================================
//  ^XNo[ɂ̎qtH[̃{^(ACR)\
//=============================================================================
procedure TSDIChildForm.CreateParams(var Params: TCreateParams);
begin
  inherited;

  if FormStyle in [fsNormal, fsStayOnTop] then begin
    if BorderStyle in [bsSingle, bsSizeable] then begin
      //̃tH[̐eDesktopƂ
      Params.WndParent := GetDesktopWindow;
    end;
  end;
end;

//=============================================================================
//  j[[t@C][VK]
//  VKɃEBhE쐬
//=============================================================================
procedure TSDIChildForm.menuNewFormClick(Sender: TObject);
begin
  SDIMainForm.CreateChildForm;
end;

//=============================================================================
//  j[[t@C][]
//=============================================================================
procedure TSDIChildForm.menuCloseClick(Sender: TObject);
begin
  Close;
end;

//=============================================================================
//  j[[t@C][Sĕ]
//  ł͉`FbNȂŋI
//=============================================================================
procedure TSDIChildForm.menuCloseAllClick(Sender: TObject);
begin
  SDIMainForm.Close;
end;

//=============================================================================
//  j[[\][d˂ĕ\]
//  CascadeWindow֐gpāCqtH[JXP[hԂɔzuĕ\
//=============================================================================
procedure TSDIChildForm.menuCascadeWindowClick(Sender: TObject);
const
  MDITILE_ZORDER = 4;
var
  WndList   : array of HWND;
  wnddxdy   : Integer;
  wndRight  : Integer;
  wndBottom : Integer;
  wndRect   : TRect;
  i         : Integer;
begin
  SetLength(WndList, Screen.FormCount);
  for i := 0 to Screen.FormCount - 1 do begin
    WndList[i] := Screen.Forms[i].Handle;
  end;

  wnddxdy   := 25;
  wndRight  := Left + Width + (Screen.FormCount - 1) * wnddxdy;
  wndBottom := Top + Height + (Screen.FormCount - 1) * wnddxdy;
  wndRect := Rect(Left, Top, wndRight, wndBottom);
  CascadeWindows(0, MDITILE_ZORDER, @wndRect, Screen.FormCount, @WndList[0]);
end;

//=============================================================================
//  j[[\][Eɕׂĕ\]
//  TileWindow֐gp
//  CEBhE̐ȂƏ㉺E^Cɕ\
//=============================================================================
procedure TSDIChildForm.menuTileVerticalClick(Sender: TObject);
var
  WndList : array of HWND;
  i       : Integer;
begin
  SetLength(WndList, Screen.FormCount);
  for i := 0 to Screen.FormCount - 1 do begin
    WndList[i] := Screen.Forms[i].Handle;
  end;

  TileWindows(0, MDITILE_VERTICAL, nil, Screen.FormCount, @WndList[0]);
  SetForegroundWindow(Handle);
end;

//=============================================================================
//  j[[\][㉺ɕׂĕ\]
//  TileWindow֐gp
//  CEBhE̐ȂƏ㉺E^Cɕ\
//=============================================================================
procedure TSDIChildForm.menuTileHorizontalClick(Sender: TObject);
var
  WndList : array of HWND;
  i       : Integer;
begin
  SetLength(WndList, Screen.FormCount);
  for i := 0 to Screen.FormCount - 1 do begin
    WndList[i] := Screen.Forms[i].Handle;
  end;

  TileWindows(0, MDITILE_HORIZONTAL, nil, Screen.FormCount, @WndList[0]);
  SetForegroundWindow(Handle);
end;

//=============================================================================
//  j[[\][SĂŏ]
//  NX̃tH[̃NXƓ̂ŏ
//=============================================================================
procedure TSDIChildForm.menuMinimizedAllClick(Sender: TObject);
var
  hWindow : THandle;
  i       : Integer;
begin
  for i := 0 to Screen.FormCount - 1 do begin
    hWindow := Screen.Forms[i].Handle;
    if GetClassNameStr(hWindow) = Self.ClassName then begin
      PostMessage(hWindow, WM_SYSCOMMAND, SC_MINIMIZE, 0);
    end;
  end;
end;

//=============================================================================
//  EBhEnhEBhENX擾
//=============================================================================
function TSDIChildForm.GetClassNameStr(hWindow: HWND): String;
var
  Len    : Integer;
  Buffer : array[0..MAX_PATH-1] of Char;
begin
  FillChar(Buffer, SizeOf(Buffer), #0);
  Len := GetClassName(hWindow, Buffer, Length(Buffer));
  if Len>0 then begin
    SetString(Result, Buffer, Len);
  end else begin
    Result := '';
  end;
end;

end.
